VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Trisection and trilateration, MARV4/2 2007"
   ClientHeight    =   8070
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   10650
   LinkTopic       =   "Form1"
   ScaleHeight     =   8070
   ScaleWidth      =   10650
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000009&
      Height          =   6855
      Left            =   120
      ScaleHeight     =   453
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   405
      TabIndex        =   0
      Top             =   240
      Width           =   6135
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   7080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu Open_PhotogrammetricMap 
         Caption         =   "Open photogrammetric map"
      End
      Begin VB.Menu OPen_Field_observations 
         Caption         =   "Open field observations"
      End
      Begin VB.Menu Simulate 
         Caption         =   "Calculate positions"
      End
      Begin VB.Menu Exit_Program 
         Caption         =   "Exit Program"
      End
   End
   Begin VB.Menu Help 
      Caption         =   "Help"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Exit_Program_Click()
End
End Sub

Private Sub Help_Click()
Form2.Visible = True
Load Form2
End Sub

Private Sub OPen_Field_observations_Click()

CommonDialog1.Filter = "Sighting obs files (*.txt, *.csv)|*.*"
CommonDialog1.DialogTitle = "File which has sightings-data!"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 15

Rem This file has csv-filenames and BKs
Do Until EOF(15)
Input #15, aFileName, BK
 Open aFileName For Input As 1



Rem Start processing
Dim Line As Long
ReDim sobs(1 To 2000) As Sighting
ReDim StartPoints(1 To 2000) As Long
Dim l As Long
Dim capu As String

nobs = 0
Do Until EOF(1)
 Line = Line + 1
 If EOF(1) = True Then GoTo DoneReading
  Rem read a line of data into  a string, let string lenght deterimine the type of observation
  Rem PLOT_ID, TREE_ID, NPA, (ID, DIST, AZI) * 5
  nobs = nobs + 1
  Input #1, sobs(nobs).plotNum, sobs(nobs).Ntree, sobs(nobs).Sp, sobs(nobs).NPA, sobs(nobs).TreeNum(1), sobs(nobs).Distance(1), sobs(nobs).Bussol(1), sobs(nobs).TreeNum(2), sobs(nobs).Distance(2), sobs(nobs).Bussol(2), sobs(nobs).TreeNum(3), sobs(nobs).Distance(3), sobs(nobs).Bussol(3), sobs(nobs).TreeNum(4), sobs(nobs).Distance(4), sobs(nobs).Bussol(4), sobs(nobs).TreeNum(5), sobs(nobs).Distance(5), sobs(nobs).Bussol(5)
  For k = 1 To 5
    If k <= sobs(nobs).NPA Then
     For l = 1 To UBound(Trees())
      If Trees(l).num = sobs(nobs).TreeNum(k) And Trees(l).plotNum = sobs(nobs).plotNum Then
       sobs(nobs).TreePos(k).x = Trees(l).Pos.x
       sobs(nobs).TreePos(k).y = Trees(l).Pos.y
       sobs(nobs).TreePos(k).Z = Trees(l).Pos.Z
       sobs(nobs).TreeSp(k) = Trees(l).spec
       sobs(nobs).Distance(k) = sobs(nobs).Distance(k) + Trees(l).d13 / 2
       If sobs(nobs).Bussol(k) > -1 Then
        sobs(nobs).IsBussol(k) = True
        sobs(nobs).Nazim = sobs(nobs).Nazim + 1
       End If
       If sobs(nobs).Distance(k) > -1 Then
        sobs(nobs).IsDistance(k) = True
        sobs(nobs).Ndist = sobs(nobs).Ndist + 1
       End If
      End If
     Next l
    End If
  Next k
    
Loop
DoneReading:
'MsgBox (nobs & " observed trees to be positioned ")
Close (1)
Call Simulate_Click
Loop
Close (15)


End Sub

Private Sub Open_PhotogrammetricMap_Click()

'On Error GoTo Virhetilanne
CommonDialog1.Filter = "Field plot data files (*.txt, *.csv)|*.*"
CommonDialog1.DialogTitle = "File which has photogrammetric control points!"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1

Rem Allocate storage for 5700 tree-observations
ReDim Trees(1 To 5700) As PhotoTree

Dim n As Long
n = 1
Do Until EOF(1)
 Input #1, Trees(n).plotNum, Trees(n).num, Trees(n).spec, Trees(n).Pos.x, Trees(n).Pos.y, Trees(n).Pos.Z, Trees(n).Zbutt, Trees(n).foto_h, Trees(n).Lidar_h, Trees(n).Dcrm_foto, Trees(n).Dcrm_LiDAR, Trees(n).Dcrm_RMSE, Trees(n).a1, Trees(n).a2, Trees(n).a3, Trees(n).Dist, Trees(n).Azim, Trees(n).InOut

 n = n + 1
Loop
MsgBox (n & " trees / fixed points read")
Close (1)

ReDim Preserve Trees(1 To n) As PhotoTree

Exit Sub

Virhetilanne:
MsgBox ("Virhe luettaessa rivi " & n)
Close (1)

End Sub

Private Sub Simulate_Click()



Dim StopBit As Long, NumOfLSAITe As Long, k As Long
Dim Plotpoints As Boolean
Dim StdevX As Double, StdevY As Double
Dim Xerr As Double, Yerr As Double
Dim XerrSum As Double, YerrSum As Double
Dim SigmaNUllSum As Double, SigmaYsum As Double, sigmaXsum As Double
Dim XerrSum2 As Double, YerrSum2 As Double
Dim Nvalid As Long

Plotpoints = True
Call DrawLines(Plotpoints)
Call Open_Input_Parameters
Call AssignTaus
'Call CreateP0

Rem Start of simulation with given constellation
'Call PrintOutputForSimu
'Open InputParam.OutputFilename For Output As 1
Close (1)

For k = 1 To nobs
 
 Rem Assign values for observations of four type
 Call AssignPointsPAandTrueObservations(k)
 Rem assign booleans for distance and azimuth
 Call DefineObservations(k)
 Call PerformPhotogrammetricObservations(k)
 Call PerformFieldObservations(k)
 
 Call InitialApproximation(k)

StartOfRecalculation:
 
 NumOfLSAITe = 0
 StopBit = CONTINUE
 Do Until (StopBit = FINISH Or NumOfLSAITe = 20)
  NumOfLSAITe = NumOfLSAITe + 1
  Call CreateMatricesAndVectorsForLSA(k)
  Call SolveLSAInMatlab(StopBit, k)
 Loop
 Rem Check if any observation has Baarda's test value in baarda() above critical in tau()
 Rem We can only use this test for redundancy of 2 and above
 Dim BaardaAffected As Boolean
 
 BaardaAffected = False
 
 GoTo OMitBaarda
 If (NumOfObservations - 2) > 1 Then
  For i = 1 To InputParam.NPA
  
   If obs(i).ISdist = True And obs(i).idDist = MaxBaardaIndex Then
    If Abs(Baarda(MaxBaardaIndex)) > tau(NumOfObservations - 2) Then
     obs(i).ISdist = False
     BaardaAffected = True
     fff = obs(i).EpsilonDist
    End If
   End If
   If obs(i).ISazim = True And obs(i).idAzim = MaxBaardaIndex Then
    If Abs(Baarda(MaxBaardaIndex)) > tau(NumOfObservations - 2) Then
     obs(i).ISazim = False
     BaardaAffected = True
     fff = obs(i).EpsilonAzim
    End If
   End If
  Next i
 End If
 
If BaardaAffected = True Then
   StopBit = RECALCULATE
   GoTo StartOfRecalculation
End If


OMitBaarda:

Call DrawObs(Plotpoints)
Call PrintOutputPerIte(k, NumOfLSAITe)
 
Rem Here we compute mean and standard deviation variables
Xerr = P0.TruePos.x - P0.InitialPos.x
Yerr = P0.TruePos.y - P0.InitialPos.y
If Abs(Xerr) < 3 And Abs(Yerr < 3) Then
 Nvalid = Nvalid + 1
 XerrSum = XerrSum + Xerr
 XerrSum2 = XerrSum2 + Xerr ^ 2
 YerrSum = YerrSum + Yerr
 YerrSum2 = YerrSum2 + Yerr ^ 2
 SigmaNUllSum = SigmaNUllSum + sigmaNull
 sigmaXsum = sigmaXsum + sigmaX
 SigmaYsum = SigmaYsum + sigmaY
End If


Next k
'MsgBox ("Ready!")
Exit Sub

Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 300
Form1.Picture1.Print "Mean(dX): " & Format$(XerrSum / Nvalid, "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 320
Form1.Picture1.Print "Mean(dY): " & Format$(YerrSum / Nvalid, "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 340
Form1.Picture1.Print "SD(dX): " & Format$(Sqr(XerrSum2 / (Nvalid - 1)), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 360
Form1.Picture1.Print "SD(dY): " & Format$(Sqr(YerrSum2 / (Nvalid - 1)), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 380
Form1.Picture1.Print "Valid(%): " & Format$(100 * (Nvalid / InputParam.NumberOfSimulations), "0.0")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 400
Form1.Picture1.Print "mean(sigmaNull): " & Format$((SigmaNUllSum / Nvalid), "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 420
Form1.Picture1.Print "mean(sigmaX): " & Format$((sigmaXsum / Nvalid), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 440
Form1.Picture1.Print "mean(sigmaY): " & Format$((SigmaYsum / Nvalid), "0.000")







MsgBox ("Done!")

End Sub
